

/*
 * ClientConnection.java
 *
 * Created on 8 de Maio de 2006, 16:56
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das.blocking;

import br.ufsc.das.util.Configuration;
import br.ufsc.das.util.ReceivedMessage;
import br.ufsc.das.util.Writer;
//import br.ufsc.das.sc.util.Message;
//import br.ufsc.das.sc.util.Writer;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.ObjectOutputStream;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.util.Hashtable;
import java.util.Map;


/**
 *
 * @author edualchieri
 */
public class ClientConnection implements Writer{
    
    private ConnectionManager manager;
    private Configuration config;    
    
    
    /** Creates a new instance of ClientConnection */
    public ClientConnection(ConnectionManager manager,Configuration config) {
        this.manager = manager;
        this.config = config;
    }
    
    public void write(int[] targets, byte[] msg){
        for(int i = 0; i < targets.length; i++){
            
            if(targets[i] == config.getProcessId()){
                //br.ufsc.das.util.Logger.println("(ClientConnection) (write) A entregar a mensagem a mim proprio");
                this.manager.getListener().deliver(new ReceivedMessage(msg,targets[i]));
            }else{
                //br.ufsc.das.util.Logger.println("(ClientConnection) (write) A enviar a mensagem para " + targets[i]);
                SynchronizedOutput out = manager.getConnectionOutput(targets[i]);                
                if(out != null){
                    ////br.ufsc.das.util.Logger.println("(ClientConnection) (write) Obtive out, vou escrever para " + targets[i]);
                    out.write(msg);
                }
                else {
                    //br.ufsc.das.util.Logger.println("(ClientConnection) (write) Obtive out, mas vem a null!!! logo nao envio para " + targets[i]);
                }
            }
        }
    }
}
