/*
 * ServerConnection.java
 *
 * Created on 8 de Maio de 2006, 15:58
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das.blocking;

import br.ufsc.das.util.Configuration;
import br.ufsc.das.util.EventListener;
import java.net.ServerSocket;
import java.net.Socket;

/**
 *
 * @author edualchieri
 */
public class ServerConnection extends Thread{
    
    private EventListener listener;

    private ConnectionManager manager;
    
    private Configuration config;
    
    /** Creates a new instance of ServerConnection */
    public ServerConnection(Configuration config, EventListener listener, ConnectionManager manager) {
        this.config = config;
        this.listener = listener;
        this.manager = manager;
        
    }
    
    public void run(){
        try{
            int port = config.getPort(config.getProcessId());
            ServerSocket ss = null;
            try{
              ss = new ServerSocket(port);
            }catch(Exception e){
                e.printStackTrace(System.out);
            }  
            System.out.println("Listening on port: "+port);
            while(true){
               Socket s = ss.accept();
               s.setTcpNoDelay(true);
               this.manager.getServerPool().execute(s);
            }
        }catch(Exception e){
            e.printStackTrace(System.out);
        }
    }
}
