package br.ufsc.das.usage.nio;

import java.io.IOException;
import java.nio.ByteBuffer;


public class ProtocolDecoder {
    /** Initial byte of a packet. */
    public static final byte STX = 0x02;
    public static final byte ATX = 0x04;
    protected byte[] buffer = null;
    protected int pos = 0;
    protected boolean newPckg = true;
    protected int tam = 0;
    protected byte ctr;
    
    public ProtocolDecoder(){
    }
/*
    public ReceivedPacket decode(ByteBuffer socketBuffer) throws IOException {
        while (socketBuffer.hasRemaining()) {
            if(newPckg){
                ctr = socketBuffer.get();
                tam = socketBuffer.getInt();
                buffer = new byte[tam];
                pos = 0;
                newPckg = false;
            }
            byte b = socketBuffer.get();
            buffer[pos] = b;
            pos++;
            if(pos >= tam){
                newPckg = true;
                return new ReceivedPacket(ctr,buffer,null);
            }
        }
        return null;
    }
*/
    public ReceivedPacket decode(ByteBuffer socketBuffer) throws IOException {
        if(newPckg){
            ctr = socketBuffer.get();
            tam = socketBuffer.getInt();
            buffer = new byte[tam];
            pos = 0;
            newPckg = false;
        }

        int numBytesToRead = Math.min((tam-pos), socketBuffer.remaining());
        socketBuffer.get(buffer,pos,numBytesToRead);
        pos += numBytesToRead;

        if(pos >= tam) {
            newPckg = true;
//            System.out.println("receive: packet size = "+(buffer.length+4));
            return new ReceivedPacket(ctr,buffer,null);
        } else {
            return null;
        }
    }

}