/*
 * ReceivedPacket.java
 *
 * Created on 25 de Maio de 2006, 17:52
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das.usage.nio;

/**
 *
 * @author edualchieri
 */
public final class ReceivedPacket {
    
    private byte ctr;
    
    private byte[] data;
    
    private byte[] authenticationCode;

    /** Creates a new instance of ReceivedPacket */
    public ReceivedPacket(byte ctr, byte[] data, byte[] authenticationCode) {
        this.ctr = ctr;
        this.data = data;
        this.authenticationCode = authenticationCode;

    }
    
    public byte[] getAuthenticationCode(){
        return this.authenticationCode;
    }
    
    public byte getCtr(){
        return this.ctr;
    }
    
    public byte[] getData(){
        return this.data;
    }

    public int getSize() {
        return 1+data.length+((authenticationCode != null)?authenticationCode.length:0);
    }
    
}
